/* Author: Kazimierz Krosman */
#include <sys/types.h>
#include <stdlib.h>
#include <dbuspolicy1/libdbuspolicy1.h>
#include <assert.h>
#include "stest_common.h"

void __dbuspolicy1_change_creds(uid_t uid, gid_t gid, const char* label);

int main(int argc, char* argv[])
{
	void* c = NULL;

	prepare_mask(argc, argv);

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
	c = dbuspolicy1_init("/sys/fs/kdbus/0-system/bus");
#pragma GCC diagnostic pop
	assert(c != NULL);

	__dbuspolicy1_change_creds(0, 0, NULL);
	tassert(dbuspolicy1_check_out(c, "org.test.test2", "org.test.test3", NULL, "org.test.Itest1", "DoIt", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) == true);

	__dbuspolicy1_change_creds(5001, 100, NULL);
	tassert(dbuspolicy1_check_in(c, "org.test.test2", "org.test.test3", NULL, 0, 0, "", "org.test.Itest1", "DoIt", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) == true);

	__dbuspolicy1_change_creds(0, 0, NULL);
	tassert(dbuspolicy1_check_out(c, "org.test.test2", "org.test.test3", "", "org.test.Itest1", "DontDoIt", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) == false);

	__dbuspolicy1_change_creds(5001, 100, NULL);
	tassert(dbuspolicy1_check_in(c, "org.test.test2", "org.test.test3", "", 0, 0,  "", "org.test.Itest1", "DontDoIt", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) ==  false);

	__dbuspolicy1_change_creds(0, 0, NULL);
	tassert(dbuspolicy1_check_out(c, "org.test.test2", "org.test.test3", "", "org.test.Itest1", "NotKnown", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) == false);

	__dbuspolicy1_change_creds(5001, 100, NULL);
	tassert(dbuspolicy1_check_in(c, "org.test.test2", "org.test.test3", "", 0, 0,  "", "org.test.Itest1", "NotKnown", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) ==  false);

	__dbuspolicy1_change_creds(0, 0, NULL);
	tassert(dbuspolicy1_check_out(c, "org.test.test2", "org.test.test3", "", "org.test.Itest2", "NotKnown", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) == false);

	__dbuspolicy1_change_creds(5001, 100, NULL);
	tassert(dbuspolicy1_check_in(c, "org.test.test2", "org.test.test3", "", 0, 0,  "", "org.test.Itest2", "NotKnown", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) ==  false);

	__dbuspolicy1_change_creds(5001, 100, NULL);
	tassert(dbuspolicy1_check_out(c, "org.test.test3", "org.test.test2", "", "org.test.Itest3", "NotKnown", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) == false);

	__dbuspolicy1_change_creds(0, 0, NULL);
	tassert(dbuspolicy1_check_in(c, "org.test.test3", "org.test.test2", "", 5001, 100,  "", "org.test.Itest3", "NotKnown", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) ==  false);

	__dbuspolicy1_change_creds(5001, 100, NULL);
	tassert(dbuspolicy1_check_out(c, "org.test.test3", "org.test.test2", "", "org.test.Itest3", "DontDoIt", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) == false);

	__dbuspolicy1_change_creds(0, 0, NULL);
	tassert(dbuspolicy1_check_in(c, "org.test.test3", "org.test.test2", "", 5001, 100,  "", "org.test.Itest3", "DontDoIt", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) ==  false);

	__dbuspolicy1_change_creds(5001, 100, NULL);
	tassert(dbuspolicy1_check_out(c, "org.test.test3", "org.test.test2", "", "org.test.Itest3", "DoIt", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) == true);

	__dbuspolicy1_change_creds(0, 0, NULL);
	tassert(dbuspolicy1_check_in(c, "org.test.test3", "org.test.test2", "", 5001, 100,  "" , "org.test.Itest3", "DoIt", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) ==  true);

	__dbuspolicy1_change_creds(5001, 100, NULL);
	tassert(dbuspolicy1_check_out(c, "org.test.test3", "org.test.test2", "", "org.test.Itest4", "DoIt", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) == true);

	__dbuspolicy1_change_creds(0, 0, NULL);
	tassert(dbuspolicy1_check_in(c, "org.test.test3", "org.test.test2", "", 5001, 100,  NULL, "org.test.Itest4", "DoIt", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) ==  true);

	__dbuspolicy1_change_creds(5001, 100, NULL);
	tassert(dbuspolicy1_check_out(c, "org.test.test9", "org.test.test10", "", "org.test.Itest4", "DoIt", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) == true);

	__dbuspolicy1_change_creds(0, 0, NULL);
	tassert(dbuspolicy1_check_in(c, "org.test.test9", "org.test.test10", "", 5001, 100,  NULL, "org.test.Itest4", "DoIt", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) ==  true);

	__dbuspolicy1_change_creds(0, 0, NULL);
	tassert(dbuspolicy1_check_out(c, "org.test.test10", "org.test.test9", "", "org.test.Itest4", "DoIt", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) == true);

	__dbuspolicy1_change_creds(5001, 100, NULL);
	tassert(dbuspolicy1_check_in(c, "org.test.test10", "org.test.test9", "", 0, 0,  NULL, "org.test.Itest4", "DoIt", DBUSPOLICY_MESSAGE_TYPE_METHOD_CALL, "", 0, 0) ==  true);

	return 0;
}
