/* Author: Kazimierz Krosman */
#include <sys/types.h>
#include <stdlib.h>
#include <dbuspolicy1/libdbuspolicy1.h>
#include <assert.h>
#include "stest_common.h"

void __dbuspolicy1_change_creds(uid_t uid, gid_t gid, const char* label);

int main(int argc, char* argv[])
{
	void* c = NULL;

	prepare_mask(argc, argv);

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
	c = dbuspolicy1_init("/sys/fs/kdbus/0-system/bus");
#pragma GCC diagnostic pop
	assert(c != NULL);

	__dbuspolicy1_change_creds(0, 0, NULL);
	tassert(dbuspolicy1_can_own(c, "org.test.test1"));

	__dbuspolicy1_change_creds(5009, 0, NULL);
	tassert(dbuspolicy1_can_own(c, "org.test.test1"));

	__dbuspolicy1_change_creds(0, 0, NULL);
	tassert(!dbuspolicy1_can_own(c, "org.test.test2"));

	__dbuspolicy1_change_creds(5009, 0, NULL);
	tassert(!dbuspolicy1_can_own(c, "org.test.test2"));

	__dbuspolicy1_change_creds(0, 0, NULL);
	tassert(!dbuspolicy1_can_own(c, "org.test.test3"));

	__dbuspolicy1_change_creds(5009, 0, NULL);
	tassert(!dbuspolicy1_can_own(c, "org.test.test3"));

	__dbuspolicy1_change_creds(0, 0, NULL);
	tassert(!dbuspolicy1_can_own(c, "org.test.test4"));

	__dbuspolicy1_change_creds(5009, 0, NULL);
	tassert(dbuspolicy1_can_own(c, "org.test.test4"));

	__dbuspolicy1_change_creds(0, 0, NULL);
	tassert(!dbuspolicy1_can_own(c, "org.test.test5"));

	__dbuspolicy1_change_creds(0, 0, NULL);
	tassert(dbuspolicy1_can_own(c, "org.test.test6"));

	__dbuspolicy1_change_creds(0, 0, NULL);
	tassert(dbuspolicy1_can_own(c, "org.test.test7"));

	tassert(dbuspolicy1_can_own(c, "a.b.c"));
	tassert(dbuspolicy1_can_own(c, "a.b"));
	tassert(!dbuspolicy1_can_own(c, "c"));
	tassert(!dbuspolicy1_can_own(c, "a.c"));
	tassert(!dbuspolicy1_can_own(c, "b.c"));

	return 0;
}
