/* Author: Kazimierz Krosman */
#include <sys/types.h>
#include <stdlib.h>
#include <dbuspolicy1/libdbuspolicy1.h>
#include <assert.h>
#include "stest_common.h"

void __dbuspolicy1_change_creds(uid_t uid, gid_t gid, const char* label);

int main(int argc, char* argv[])
{
	void* c = NULL;

	prepare_mask(argc, argv);

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
	c = dbuspolicy1_init("/sys/fs/kdbus/0-system/bus");
#pragma GCC diagnostic pop
	assert(c != NULL);

	__dbuspolicy1_change_creds(0, 0, NULL);
	tassert(dbuspolicy1_check_out(c, "",  "org.test.test3", "", "/an/object/path", "", DBUSPOLICY_MESSAGE_TYPE_SIGNAL, "", 0, 0) == true);

	__dbuspolicy1_change_creds(5010, 0, NULL);
	tassert(dbuspolicy1_check_out(c, "",  "bli.bla.blubb", "", "/an/object/path", "", DBUSPOLICY_MESSAGE_TYPE_SIGNAL, "", 0, 0) == false);

	return 0;
}
